#include <conio.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

void precalcula (void);
void pon_pixel ( int x, int y, char color, char *donde);
void circulo ( int x, int y, int radio, char color);
void modo ( char modo);
void prepara_paleta( void);
void rota_paleta( void);
void remapea_color ( char color, char r, char g, char b);
void prepara_tuning ( void);
void tuning ( void);

float seno [6283];
float coseno [6283];
unsigned int pant_off [200];
char paleta [256][3];

void main ( void)
{
   register int i, j=0;
   char color=0;
   printf ("\n\n Este programa prueba la rutina para dibujar crculos, junto"
	   " con un efectillo.\n Por Rubn Franco Molina.");
   precalcula();
   getch();
   modo(0x13);
   prepara_paleta();
   for ( i=0; i<200; i++,color++)
      circulo ( 160, 100, i, color);
   while ( !kbhit() )
      rota_paleta();
   getch();
   prepara_tuning();
   while ( !kbhit() )
      tuning();
   modo (3);
   printf ("ADIS");
}

void precalcula (void)
{
   float i;
   int j=0;
   for ( i=.001; i<6.285 && j<6283; i+=0.001, j++)
      seno [j]=(float)sin(i), coseno[j]=(float)cos(i);
   for ( j=0; j<200; j++)
      pant_off [j]=320*j;
}

void pon_pixel ( int x, int y, char color, char *donde)
{
   asm{
    mov cx, [x]
    mov bx, [y]
    cmp cx, 320
    ja fin
    cmp bx, 200
    ja fin
    mov ax, 0A000h
    mov es, ax
    shl bx, 1
    push di
    mov di, word ptr [pant_off + bx]
    add di, cx
    mov al, color
    stosb
    pop di
   }
fin:;
}

void circulo ( int x, int y, int radio, char color)
{
   register int i;
   for ( i=0; i<6282; i++)
     pon_pixel ( x+radio*coseno[i], y+radio*seno[i], color, (char *)0xA0000000);
}

void modo ( char modo)
{
   asm{
   xor ah, ah
   mov al, modo
   int 10h
   }
}

void prepara_paleta (void)
{
   int i,color=100;
   for ( i=1; i<100; i++)
      {
      remapea_color ( i, i/6,20+ i/5, i/6);
      paleta[i][0]=i/6; paleta[i][1]=20+i/5; paleta[i][2]=i/6;
      }
   for ( i=100; i>=0; i--,color++)
      {
      remapea_color ( color, i/6,20+ i/5, i/6);
      paleta[color][0]=i/6; paleta[color][1]=20+i/5; paleta[color][2]=i/6;
      }

}

void rota_paleta ( void)
{
   register int i;
   char color[3];
   color[0]=paleta[200][0]; color[1]=paleta[200][1]; color[2]=paleta[200][2];
   for ( i=200; i>0; i--)
      {
      paleta[i][0]=paleta[i-1][0];
      paleta[i][1]=paleta[i-1][1];
      paleta[i][2]=paleta[i-1][2];
      }
   paleta[1][0]=color[0]; paleta[1][1]=color[1]; paleta[1][2]=color[2];
   asm   mov dx, 3dah
uno:
   asm   in al, dx
   asm   test al, 8
   asm   jnz uno
dos:
   asm   in al, dx
   asm   test al, 8
   asm   jz dos
   for (i=0; i<256; i++)
	 remapea_color ( i, paleta[i][0], paleta[i][1], paleta[i][2]);
}

void remapea_color ( char color, char r, char g, char b)
{
   asm{
   mov dx, 3C8h
   mov al, color
   out dx, al
   inc dx
   mov al, r
   out dx, al
   mov al, g
   out dx, al
   mov al, b
   out dx, al
   }
}

void prepara_tuning ( void)
{
   int i, j;
   for ( i=0; i<200; i++)
      for ( j=0; j<320; j++)
	 pon_pixel ( j, i, (char)random(16)+1,(char *) 0xA0000000);
   for (i=1; i<17; i++)
      {
      remapea_color ( i, i*4, i*4, i*4);
      paleta[i][0]=i*4; paleta[i][1]=i*4; paleta[i][2]=i*4;
      }
}

void tuning ( void)
{
   register int i;
   char color[3];
   color[0]=paleta[16][0]; color[1]=paleta[16][1]; color[2]=paleta[16][2];
   for ( i=16; i>0; i--)
      {
      paleta[i][0]=paleta[i-1][0];
      paleta[i][1]=paleta[i-1][1];
      paleta[i][2]=paleta[i-1][2];
      }
   paleta[1][0]=color[0]; paleta[1][1]=color[1]; paleta[1][2]=color[2];

   asm   mov dx, 3dah
uno:
   asm   in al, dx
   asm   test al, 8
   asm   jnz uno
dos:
   asm   in al, dx
   asm   test al, 8
   asm   jz dos

   for (i=0; i<17; i++)
      remapea_color ( i, paleta[i][0], paleta[i][1], paleta[i][2]);
}